import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Modellen{
    private String farg;
    public Modellen(){
	farg = "Svart";
    }

    public String geFargen(){ 
	return farg;
    }
    
    public void uppdateraTillstand(){ 
	if(farg.equals("Svart"))
	    farg = "Vit"; 
	else
	    farg = "Svart";
    } 
}

class Vy extends JPanel{ 
    private Modellen mod;

    public Vy(Modellen m){
	super();
	setSize(200,200);
	mod = m;
	setLayout(new BorderLayout());
    }
    

    public void updatemin(){ 
	repaint();

    } 

    public void paintComponent(Graphics g){
	g.setColor(Color.white);
	g.fillRect(0,0,200,200);
	g.setColor(Color.black);
	String f = mod.geFargen();
	g.drawString(f, 100, 50);
    } 
    
}


class Kontroll extends JButton implements ActionListener{ 
    private Modellen mod;
    private Vy vy;
    
    public Kontroll(Modellen m,Vy v){
	super("Klicka pa mig");
	mod = m;
	vy =v;
	addActionListener(this);
	javax.swing.Timer t=new javax.swing.Timer(1000,this);
	t.start();
    }
    
    public void actionPerformed(ActionEvent ae){
	uppdatera();
    }
    
    public void uppdatera() { 
	mod.uppdateraTillstand();
	vy.updatemin();
    }
}

public class MVC1{
    public static void main(String[] args){ 
	JFrame f=new JFrame();
	Modellen mod = new Modellen(); 
	Vy vy = new Vy(mod);
	f.getContentPane().add(vy);
	Kontroll kontr = new Kontroll(mod,vy);
	vy.add(kontr, BorderLayout.SOUTH);
	f.setSize(200,200);
	f.setVisible(true);

    } 
}
